<template>
  <div class="content">
    <!-- <h4>Tabel Mata Kuliah KOTA</h4> -->
    <div style="margin-top: 50px;">
      <span style="font-size: 18px;"
        ><a href="#/dashboard/report-mata-kuliah-kaprodi" style="color: grey"
          >Daftar Mata Kuliah KOTA
        </a></span
      >
      <span style="font-size: 17px; padding: 0px 5px"> > </span>
      <span style="font-size: 18px">Input Booking Prioritas MK KOTA</span>
    </div>
    <form ref="form" novalidate class="md-layout" @submit.prevent="onSubmit">
      <md-card
        class="md-layout-item md-size-95 md-small-size-100"
        style="padding: 0px 20px 30px 20px; margin-left: 30px"
      >
        <md-card-header>
          <div class="md-title">
            <h2 style="letter-spacing: 2px;color: green;margin-top:30px;">
              <strong>Input Booking Prioritas MK KOTA</strong>
            </h2>
          </div>
        </md-card-header>

        <md-card-content>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('periode_id')">
                <label for="periode_id">Tahun Akademik...</label>
                <md-select
                  name="periode_id"
                  id="periode_id"
                  v-model="bookingPriorityData.periode_id"
                  md-dense
                  :disabled="sending"
                >
                  <md-option
                    v-for="(periode, key) in periodeList"
                    :key="key"
                    :value="periode.id"
                    style="width:100%; left: 10px;"
                  >
                    <div
                      v-if="periode.semester == '01' || periode.semester == '1'"
                    >
                      {{ periode.tahun }} (Ganjil)
                    </div>
                    <div
                      v-if="periode.semester == '02' || periode.semester == '2'"
                    >
                      {{ periode.tahun }} (Genap)
                    </div>
                  </md-option>
                </md-select>
                <span
                  class="md-error"
                  v-if="!$v.bookingPriorityData.periode_id.required"
                  >Tahun Akademik is required</span
                >
              </md-field>
            </div>
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('mata_kuliah_id')">
                <label for="mata_kuliah_id">Mata Kuliah...</label>
                <md-select
                  name="mata_kuliah_id"
                  id="mata_kuliah_id"
                  v-model="bookingPriorityData.mata_kuliah_id"
                  md-dense
                  :disabled="sending"
                >
                  <md-option
                    v-for="(mata_kuliah, key) in mataKuliahList"
                    :key="key"
                    :value="mata_kuliah.id"
                    style="width:100%; left: 10px;"
                  >
                    {{ mata_kuliah.nama_mk }}
                  </md-option>
                </md-select>
                <span
                  class="md-error"
                  v-if="!$v.bookingPriorityData.mata_kuliah_id.required"
                  >Mata Kuliah is required</span
                >
              </md-field>
            </div>
          </div>
          <div class="md-layout md-gutter">
            <div class="md-layout-item md-small-size-100">
              <md-field :class="getValidationClass('peserta')">
                <label for="peserta">NIM Mahasiswa...</label>
                <md-input
                  name="peserta"
                  id="peserta"
                  v-model="bookingPriorityData.peserta"
                  md-dense
                  :disabled="sending"
                  maxlength="10"
                >
                </md-input>
                <span
                  class="md-error"
                  v-if="!$v.bookingPriorityData.peserta.required"
                  >NIM is required</span
                >
              </md-field>
            </div>
          </div>
        </md-card-content>

        <md-card-actions style="padding-top: 50px">
          <md-button
            type="submit"
            class="md-login md-success md-lg md-round"
            :disabled="sending"
            style="height: 50px; width: 140px"
            ><span
              style="color: white; font-size: 17px; text-transform: capitalize; bottom: 5px"
            >
              Submit
            </span>
          </md-button>
        </md-card-actions>

        <md-progress-bar md-mode="indeterminate" v-if="sending" />
      </md-card>

      <md-snackbar :md-active.sync="userSaved"
        >Data Booking Prioritas berhasil diupdate</md-snackbar
      >
    </form>
  </div>
</template>

<script>
import { mapState, mapActions } from "vuex";
import { validationMixin } from "vuelidate";
import { required, minLength, maxLength } from "vuelidate/lib/validators";

export default {
  name: "FormValidation",
  mixins: [validationMixin],
  data: () => ({
    form: [
      {
        periode_id: null,
        mata_kuliah_id: null,
        peserta: null
      }
    ],
    userSaved: false,
    sending: false
  }),
  validations: {
    bookingPriorityData: {
      periode_id: {
        required
      },
      mata_kuliah_id: {
        required
      },
      peserta: {
        required
      }
    }
  },
  props: {
    header: {
      type: String,
      default: require("@/assets/img/gedung-upj.jpg")
    },
    image: {
      type: String,
      default: require("@/assets/img/bg-red-batik.png")
    },
    logo: {
      type: String,
      default: require("@/assets/img/logo/upj-logo.png")
    }
  },
  computed: {
    ...mapState("bookingPriority", ["bookingPriorityData"]),
    ...mapState("periode", ["periodeList"]),
    ...mapState("mataKuliah", ["mataKuliahList", "kaprodiMkList"]),
    headerStyle() {
      return {
        backgroundImage: `url(${this.header})`
      };
    }
  },
  methods: {
    ...mapActions("bookingPriority", [
      "getBookingPriority",
      "updateBookingPriority"
    ]),
    ...mapActions("periode", ["getPeriodeList"]),
    ...mapActions("mataKuliah", ["getMataKuliahList"]),
    async onFetchData() {
      await this.getBookingPriority({ id: this.$route.params.id });
      await this.getPeriodeList();
      await this.getMataKuliahList();
    },
    async onSubmit() {
      this.$v.$touch();
      this.sending = true;
      window.setTimeout((this.userSaved = true), 2000);
      if (!this.$v.invalid) {
        try {
          await this.updateBookingPriority({
            id: this.$route.params.id,
            payload: this.bookingPriorityData
          });
          this.sending = false;
          this.bookingPriorityData = {};
          this.$router.push({ name: "booking-priority" });
        } catch (error) {
          this.sending = false;
          throw Error(error);
        }
      }
    },
    getValidationClass(fieldName) {
      const field = this.$v.bookingPriorityData[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    saveUser() {
      this.sending = true;
      window.setTimeout(() => {
        this.userSaved = true;
        this.sending = false;
        this.clearForm();
      }, 1500);
    },
    validateUser() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.saveUser();
      }
    }
  },
  async mounted() {
    await this.onFetchData();
    this.onResponsiveInverted();
    window.addEventListener("resize", this.onResponsiveInverted);
  }
};
</script>

<style lang="scss" scoped></style>

<style lang="css">
.md-progress-bar {
  margin: 24px;
}
</style>
